// POBoxDAFPOBox FEP5-wayirQ[^Lɂ܂B
// ------------------------------------------------------------
// Copyright (C) 2005  SAITO Shukaku (shukaku@sai10.nu)
//
// {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
// \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
// ̒炢ꂩIÃo[W߂ɏ]Ė{vO
// ĔЕz܂͕ύX邱Ƃł܂B
//
// {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
// ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
// GNU ʌLgpǂ݂B
//
// Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
// ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
// Cambridge, MA 02139, USA ֎莆ĂB

#include <PalmOS.h>
#include "POBoxDA.h"

#define POBoxDACreatorID 'pbDA'
#define POBoxDAPrefsID 0
#define POBoxDAPrefsVersion 0x0001

// preference
struct _prefs
{
    Int16 lastX, lastY;
    FontID font;
};
    
// global variable
struct _global
{
    _prefs prefs;
    Int16 fromX, fromY;
    Boolean moving;
    RectangleType windowBounds;
    FormType *form;
    FormType *parent_form;
    FieldType *parent_field;
};

extern "C" { void start(); }
extern void DAMain();
extern Err GetCurAppName( Char *name );

/* This code must be here. (first of code section)*/
/* ̃R[h͂ɂȂႾ߁B(R[ḧ̎n)*/
void start()
{
    DAMain();
}

/*========================================================================*/

/* Followings are real implementatiom */
/* ȉۂ̎ */

static void debug( const Char *function,
                   const Int16 line, const Char *message )
{
    Char buffer[ 8 ];
    StrPrintF( buffer, "%d", line );
    FrmCustomAlert( DEBUG_ALERT, function, buffer, message );
}

#define DEBUG( message ) // debug( __func__, __LINE__, message )
    
static void *GetObjectPtr( Int16 objectID )
{
    FormType *form;
    Int16 index;
    void *ptr;

    form = FrmGetActiveForm();
    index = FrmGetObjectIndex( form, objectID );
    ptr = FrmGetObjectPtr( form, index );
    return ptr;
}

static void flush_field( _global &g )
{
    FieldType *da_field = ( FieldType * )GetObjectPtr( IdPOBoxField );
    Char *field_text = FldGetTextPtr( da_field );
    if( g.parent_field && field_text )
    {
        FrmEraseForm( g.form );
        FrmSetActiveForm( g.parent_form );
        Int16 length = FldGetTextLength( da_field );
        FldInsert( g.parent_field, field_text, length );
        FrmDrawForm( g.form );
        FrmSetActiveForm( g.form );
        FldDelete( da_field, 0, length );
        FldGrabFocus( da_field );
    }
}

/* Initialize Preference */
/* Preference ̏ */
static void InitPrefs( _global *g )
{
    MemSet( &g->prefs, sizeof( _prefs ), 0L );
    g->prefs.lastX = DefaultFrameXPos;
    g->prefs.lastY = DefaultFrameYPos;
    g->prefs.font = stdFont;
    g->moving = false;
}

/* Load Preference */
/* vt@Xǂݍ */
static void LoadPrefs( _global *g )
{
    Int16 version;
    UInt16 prefSize;

    Char buffer[ 20 ];
    StrPrintF( buffer, "(%d,%d)", g->prefs.lastX, g->prefs.lastY );
    DEBUG( buffer );

    prefSize = sizeof( g->prefs );
    version = PrefGetAppPreferences( POBoxDACreatorID,
                                     POBoxDAPrefsID,
                                     &g->prefs,
                                     &prefSize,
                                     true );
     StrPrintF( buffer, "(%d,%d) %d",
                g->prefs.lastX, g->prefs.lastY, version );
     DEBUG( buffer );

    if( version == noPreferenceFound )
    {
        /* No preference found, create it with default value */
        /* Preference Ȃ̂ŁAftH[gݒ */
        InitPrefs( g );
    }
    else
    {
        switch( version )
        {
        case POBoxDAPrefsVersion:
            break;
        default:
            InitPrefs( g );
            break;
        }
    }
}

/* Save Preference */
/* vt@Xۑ */
static void SavePrefs( _global *g )
{
    Char buffer[ 20 ];
    StrPrintF( buffer, "(%d,%d)", g->prefs.lastX, g->prefs.lastY );
    DEBUG( buffer );

    PrefSetAppPreferences(
        POBoxDACreatorID,
        POBoxDAPrefsID,
        POBoxDAPrefsVersion,
        &g->prefs,
        sizeof( g->prefs ),
        true // persistent
    );
}

/* Initialize global variables */
/* O[oϐ */
static _global *InitGlobals()
{
    _global *g;
    g = ( _global * )MemPtrNew( sizeof( _global ) );
    return g;
}

/* Get Parent application name ... but not used in this DA */
/* ẽAvP[V擾 ...  DA ł͖gp */
Err GetCurAppName( Char *name )
{
    Err error;
    UInt16 cardNo;
    LocalID dbID;

    error = SysCurAppDatabase( &cardNo, &dbID );
    if( !error ) error = DmDatabaseInfo( cardNo, dbID, name,
                                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0 );
    return error;
}

/* Tapped inside of this DA's form ? */
/*  DA ̃tH[̓Ń^bvꂽ? */
static Boolean IsInside( RectangleType *r, Int16 x, Int16 y )
{
    return ( 0 <= x && x <= r->extent.x && 0 <= y && y <= 12 );
}

/* Tapped outside of this DA's form ? */
/*  DA ̃tH[̊OŃ^bvꂽ? */
static Boolean IsOutside( RectangleType *r, Int16 x, Int16 y )
{
    return !( 0 <= x && x <= r->extent.x && 0 <= y && y <= r->extent.y );
}

/* Draw frame with EX-OR mode */
/* t[ EX-OR [hŕ` */
static void ExorFrame( _global *g )
{
    RectangleType r;

    r.topLeft.x = g->windowBounds.topLeft.x;
    r.topLeft.y = g->windowBounds.topLeft.y;
    r.extent.x = FrameXSize;
    r.extent.y = FrameYSize;
    WinInvertRectangleFrame( boldRoundFrame, &r );
}

/* Event Handler */
/* Cxgnh[ */
static Boolean DAHandleEvent( EventType *event, _global *g )
{
    Boolean done = false;
    Boolean handled = false;
    Int16 moveX, moveY;
    UInt16 ch;
    RectangleType windowBounds;
    RectangleType displayBounds;    
    FieldType *field;

    switch( event->eType )
    {
    case appStopEvent:
        /* Send appStopEvent to original application */
        /* appStopEvent AƂ̃AvP[Vɑ */
        EvtAddEventToQueue( event );
        done = true;
        handled = true;
        break;

    case keyDownEvent:
        ch = event->data.keyDown.chr;
        if( TxtCharIsHardKey( event->data.keyDown.modifiers, ch ) )
        {
            /* maybe 'HotSync!' button pressed ? */
            /* HotSync! {^ꂽ? */
            EvtAddEventToQueue( event );
            done = true;
            handled = true;
        }
        else
        {
            UInt16 arrowKey = 0;
            switch( ch )
            {
                case vchrRockerUp: arrowKey = chrUpArrow; break;
                case vchrRockerDown: arrowKey = chrDownArrow; break;
                case vchrRockerRight: arrowKey = chrRightArrow; break;
                case vchrRockerLeft: arrowKey = chrLeftArrow; break;
                case vchrRockerCenter: arrowKey = chrLineFeed; break;
            }
            if( ch == vchrRockerCenter && TsmGetFepMode( NULL ) == 129 )
            {
                done = true;
                handled = true;
            }
            else if( ch == vchrRockerDown && TsmGetFepMode( NULL ) == 129 )
            {
                FrmSetFocus( g->form, FrmGetObjectIndex( g->form, CopyButton ) );
                handled = true;
            }
            else if( arrowKey == 0 )
            {
                done = false;
                handled = false;
            }
            else
            {
                EvtEnqueueKey( arrowKey, 0, 0 );
                done = false;
                handled = true;
            }
        }
        break;
        
    /* Following implements 'Draggable' feature */
    /* ȉ́AhbKu@\̎ */
    case penDownEvent:
        WinGetBounds( FrmGetWindowHandle( g->form ), &windowBounds );
        if( IsInside( &windowBounds, event->screenX, event->screenY ) )
        {
            /* Start Drag */
            /* hbOJn */
            g->fromX = windowBounds.topLeft.x + event->screenX;
            g->fromY = windowBounds.topLeft.y + event->screenY;
            g->moving = true;
            g->windowBounds = windowBounds;
            FrmEraseForm( g->form );
            WinSetDrawWindow( WinGetDisplayWindow() );
            /* Draw only frame as dragging */
            /* hbÓAg\ */
            ExorFrame( g );
            handled = true;
        }
        else if( IsOutside( &windowBounds, event->screenX, event->screenY ) )
        {
            /* Pen tapped on Outside of form -- quit */
            /* tH[̊OŃ^bvꂽ -- I */
            done = true;
            handled = true;
        }
        break;

    case penMoveEvent:
        if( g->moving )
        {
            moveX = event->screenX - g->fromX; g->fromX = event->screenX;
            moveY = event->screenY - g->fromY; g->fromY = event->screenY;

            /* Erase previous frame */
            /* Oɕ`悵g */
            WinSetDrawWindow( WinGetDisplayWindow() );
            ExorFrame( g );

            /* Compute new form position */
            /* VtH[ʒuvZ */
            WinGetDrawWindowBounds( &displayBounds );
            g->windowBounds.topLeft.x += moveX;
            g->windowBounds.topLeft.y += moveY;
            if( g->windowBounds.topLeft.x < FrameWidth )
            {
                g->windowBounds.topLeft.x = FrameWidth;
            }
            if( g->windowBounds.topLeft.y < FrameWidth )
            {
                g->windowBounds.topLeft.y = FrameWidth;
            }
            if( g->windowBounds.topLeft.x + 
                g->windowBounds.extent.x +
                FrameWidth >= displayBounds.extent.x )
            {
                g->windowBounds.topLeft.x =
                    displayBounds.extent.x - 
                    g->windowBounds.extent.x - FrameWidth;
            }
            if( g->windowBounds.topLeft.y + 
                g->windowBounds.extent.y +
                FrameWidth >= displayBounds.extent.y )
            {
                g->windowBounds.topLeft.y =
                    displayBounds.extent.y - 
                    g->windowBounds.extent.y - FrameWidth;
            }
            /* Draw new frame */
            /* Vg\ */
            ExorFrame( g );
            handled = true;
        }
        break;

    case penUpEvent:
        if( g->moving )
        {
            /* Erase last frame */
            /* ȑO̘g */
            WinSetDrawWindow( WinGetDisplayWindow() );
            ExorFrame( g );
            /* Save last position into preference */
            /* vt@XɁAŌ̈ʒuL^ */
            g->prefs.lastX = g->windowBounds.topLeft.x;
            g->prefs.lastY = g->windowBounds.topLeft.y;
            g->moving = false;
            WinSetBounds( FrmGetWindowHandle( g->form ), &g->windowBounds );
            FrmDrawForm( g->form );
            field = ( FieldType * )GetObjectPtr( IdPOBoxField );
            FldGrabFocus( field );
            handled = true;
        }
        break;

    case ctlSelectEvent:
        field = ( FieldType * )GetObjectPtr( IdPOBoxField );
        switch( event->data.ctlSelect.controlID )
        {
        case CopyButton:
            FldCopy( field );
            handled = true;
            break;
        case PasteButton:
            FldPaste( field );
            handled = true;
            break;
        case FLUSH_BUTTON:
            flush_field( *g );
            handled = true;
            break;
        }
        break;

    case menuEvent:
        field = ( FieldType * )GetObjectPtr( IdPOBoxField );
        switch( event->data.menu.itemID )
        {
        case COPY_COMMAND:
            FldCopy( field );
            handled = true;
            break;
        case PASTE_COMMAND:
            FldPaste( field );
            handled = true;
            break;
        case FLUSH_COMMAND:
            flush_field( *g );
            handled = true;
            break;
        case 2111:
            g->prefs.font = FontSelect( g->prefs.font );
            FldSetFont( field, g->prefs.font );
            handled = true;
            break;
        }
        break;

    default:
        break;
    }
    if( !handled )
    {
        FrmHandleEvent( FrmGetActiveForm(), event );
    }
    return done;
}

/* Event Loop */
/* Cxg[v */
static void EventLoop( _global *g )
{
    EventType event;
    Boolean done = false;
    UInt16 error;
    do
    {
        EvtGetEvent( &event, evtWaitForever );
        if( SysHandleEvent( &event ) ) continue;
        if( MenuHandleEvent( NULL, &event, &error ) ) continue;
        done = DAHandleEvent( &event, g );
    } while( !done );
}

/* main function body */
/* C֐{ */
void DAMain()
{
    _global *g;
    FieldType *field;
    UInt32 feature = 0;

    /* Check duplicate invocation of POBox DA */
    /* (POBox DA) DA ̓dNoB*/
    if( FtrGet( POBoxDACreatorID, 0, &feature ) == 0 )
    {
        /* Already POBox DA is invoked -- duplicate invocation */
        /* ł POBox DA NĂ -- dN */
        return;
    }
    else
    {
        /* To avoid duplicate invocation, set feature */
        /* dN邽߂ɃtB[`[o^ */
        FtrSet( POBoxDACreatorID, 0, feature );
    }

    /* Allocate && initialize global variables */
    /* O[oϐ̈̊蓖ĂƂ̏ */
    g = InitGlobals();
    if( g == NULL )
    {
        /* Fail to allocate global variables area */
        /* O[oϐ̈̊蓖ĂɎs */
        return;
    }

    /* Load Preferences from last invoked */
    /* ȑONꂽƂ Preference [h */
    LoadPrefs( g );

    DEBUG( "loaded" );

    // etH[̃tB[hL^B
    g->parent_form = FrmGetActiveForm();
    UInt16 focusIndex = FrmGetFocus( g->parent_form );
    g->parent_field = NULL;
    if( focusIndex != noFocus )
    {
        switch( FrmGetObjectType( g->parent_form, focusIndex ) )
        {
        case frmFieldObj:
            g->parent_field =
                ( FieldType * )FrmGetObjectPtr( g->parent_form, focusIndex );
            break;

        case frmTableObj:
            TableType *table =
                ( TableType * )FrmGetObjectPtr( g->parent_form, focusIndex );
            g->parent_field = ( FieldType * )TblGetCurrentField( table );
            break;
        }
    }

    /* Activate Main Form */
    /* CtH[N */
    g->form = FrmInitForm( IdDAForm );

    /* Restore last position */
    /* ŌɋNꂽʒu𕜌 */
    WinGetBounds( FrmGetWindowHandle( g->form ), &g->windowBounds );
    g->windowBounds.topLeft.x = g->prefs.lastX;
    g->windowBounds.topLeft.y = g->prefs.lastY;
    WinSetBounds( FrmGetWindowHandle( g->form ), &g->windowBounds );
    FrmSetActiveForm( g->form );
    FrmDrawForm( g->form );

    //ToggleFep();
    TsmSetFepMode( NULL, tsmFepModeDefault );
    
    // tB[hɃtH[JX^B
    //FrmSetFocus( g->form, FrmGetObjectIndex( g->form, IdPOBoxField ) );
    //EvtEnqueueKey( chrRightArrow, 0, 0 );
    field = ( FieldType * )GetObjectPtr( IdPOBoxField );
    FldSetFont( field, g->prefs.font );
    FldGrabFocus( field );

    /* goto event handler */
    /* Cxgnh[ɐn */
    EventLoop( g );

    //ToggleFep();
    TsmSetFepMode( NULL, tsmFepModeOff );

    /* finish up application */
    /* AvP[V̏I */
    FrmEraseForm( g->form );
    field = ( FieldType * )GetObjectPtr( IdPOBoxField );
    MemHandle textHandle = FldGetTextHandle( field );
    FldSetTextHandle(field, NULL);
    FrmDeleteForm( g->form );
    FrmSetActiveForm( g->parent_form );

    if( textHandle != NULL )
    {
        Char *fieldText = ( Char * )MemHandleLock( textHandle );
        UInt16 length = StrLen( fieldText );
        if( g->parent_field )
        {
            FldInsert( g->parent_field, fieldText, length );
        }
        MemHandleUnlock( textHandle );
        MemHandleFree( textHandle );
    }
    
    SavePrefs( g );

    DEBUG( "saved" );

    /* Release feature */
    /* tB[`[ */
    if( FtrGet( POBoxDACreatorID, 0, &feature ) == 0 )
    {
        FtrUnregister( POBoxDACreatorID, 0 );
    }

    /* Release Global area */
    /* O[oϐ̈ */
    MemPtrFree( g );
}
